//---------------------------------------------------------------------------

#ifndef FiltersH
#define FiltersH


#include <math.h>
#include <values.h>
#include <mem.h>

#ifndef TWOPI
#define TWOPI 2*M_PI
#endif
////////////////////////////////////////////////////////////////////////////////
class TLowPassFilter
{
  private:
        float *Z;  //  
        float *B;  // 
        int N;
  public:
        TLowPassFilter(float Fc);
        float filter(float s);
        int filter(float s[], int n);
        ~TLowPassFilter();

};
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////    /////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
class TFilter
{ protected:
  private:
        float *Z;  //  
        float *B;  // 
        int N;
        float F0;
        float BW;
  public:
        TFilter(float F1, float F2);
        ~TFilter();
        void filter(float * x, int n, float * y);
        float filter(float x);
        float getF0(void);
        float getBW(void);
};
//------------------------------------------------------------------------------
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
////           ////
////////////////////////////////////////////////////////////////////////////////
class TCosBPFilter
{  private:
       float * Z; //  
       float *B;  // 
       int N;
   public:
        TCosBPFilter(float F1, float F2, float betta);
        void filter(float * x, int n, float * y);
        float filter(float x);
        ~TCosBPFilter();
};
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------

////////////////////////////////////////////////////////////////////////////////
/////////////////////////////   ////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
class TAdaptiveFilter
{
   private:
       float * Z; //  
       float *B;  // 
       int N;
       float MU;
       float E;

   public:
        TAdaptiveFilter(int n, float mu);
        float filter(float x);
        ~TAdaptiveFilter();
};
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
////////////       //////////////////
////////////////////////////////////////////////////////////////////////////////
class TIIRLPF
{
  private:
   float A, B;
   float * Y;
   int N;
  public:
        TIIRLPF(float Fs, int Nz);
        ~TIIRLPF();
        float filter(float x);
        float filter(float * x, int n);

};
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
///////////    2-  //////////////////////////
////////////////////////////////////////////////////////////////////////////////
class TIIRBPF2
{ private:
    double A0, A1, A2;
    double B1, B2;
    double Y0, Y1, Y2;
    double X0, X1, X2;
    float F0, BW0;
  public:
        TIIRBPF2(float Fc, float BW);
        float filter(float x);
        float filter(float x[], int n, float y[]);
        float getF0(void);
        float getBW(void);
};
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

/////////    HGA  DCF ////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
class TIIR_DCFHGA
{ private:
        float F0;
        float BW0;

  public:
        TIIR_DCFHGA(float Fc, float BW);
        float filter(float x);
        float filter(float x[], int n, float y[]);
        float getF0(void);
        float getBW(void);
};
////////////////////////////////////////////////////////////////////////////////
#endif
